/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 27/10/2017
 --------------------------------------------------------
*/
package com.portofolio.entity;

import org.hibernate.annotations.ForeignKey;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.*;

import javax.persistence.*;
import javax.validation.constraints.*;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.portofolio.entity.Departemen;
import com.portofolio.entity.Profile;
import com.portofolio.entity.vo.BankAccountId;

import org.hibernate.annotations.Type;



@Entity
@Table(name = "BankAccount_M",indexes = {@Index(name = "BankAccount_M_Index",  columnList="statusEnabled", unique = false) })
@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@JsonIgnoreProperties({ "hibernateLazyInitializer", "handler" })
public class BankAccount {
    
    @EmbeddedId
    private BankAccountId id ;
    
    private static final String cDefBankAccountNama = VARCHAR + AWAL_KURUNG + 80 + AKHIR_KURUNG ;
    @Column(name = "BankAccountNama", columnDefinition = cDefBankAccountNama)
    @NotNull(message = "bankaccount.bankaccountnama.notnull")
    private String bankAccountNama;
    
    private static final String cDefBankAccountKantor = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG ;
    @Column(name = "BankAccountKantor", columnDefinition = cDefBankAccountKantor)
    private String bankAccountKantor;
    
    private static final String cDefBankAccountNomor = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG ;
    @Column(name = "BankAccountNomor", columnDefinition = cDefBankAccountNomor)
    @NotNull(message = "bankaccount.bankaccountnomor.notnull")
    private String bankAccountNomor;
    
    private static final String cDefBankAccountAtasNama = VARCHAR + AWAL_KURUNG + 80 + AKHIR_KURUNG ;
    @Column(name = "BankAccountAtasNama", columnDefinition = cDefBankAccountAtasNama)
    @NotNull(message = "bankaccount.bankaccountatasnama.notnull")
    private String bankAccountAtasNama;
    
    private static final String cDefKeteranganLainnya = VARCHAR + AWAL_KURUNG + 150 + AKHIR_KURUNG ;
    @Column(name = "KeteranganLainnya", columnDefinition = cDefKeteranganLainnya)
    private String keteranganLainnya;
    
    private static final String cDefNoCM = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG ;
    @Column(name = "NoCM", columnDefinition = cDefNoCM)
    private String noCM;
    
    private static final String cDefKdRekanan =INTEGER;
    @Column(name = "KdRekanan", columnDefinition = cDefKdRekanan)
    private Integer kdRekanan;
    
    private static final String cDefKdPegawai = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG ;
    @Column(name = "KdPegawai", columnDefinition = cDefKdPegawai)
    private String kdPegawai;
    
    private static final String cDefKdCaraBayar =INTEGER;
    @Column(name = "KdCaraBayar", columnDefinition = cDefKdCaraBayar)
    private Integer kdCaraBayar;
    
    private static final String cDefKdAccount =INTEGER;
    @Column(name = "KdAccount", columnDefinition = cDefKdAccount)
    private Integer kdAccount;
    
    private static final String cDefNoUrutPrimary =INTEGER;
    @Column(name = "NoUrutPrimary", columnDefinition = cDefNoUrutPrimary)
    @NotNull(message = "bankaccount.nourutprimary.notnull")
    private Integer noUrutPrimary;
    
    private static final String cDefKdDepartemen = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG ;
    @Column(name = "KdDepartemen", columnDefinition = cDefKdDepartemen)
    private String kdDepartemen;
    
    private static final String cDefStatusEnabled =INTEGER;
    @Column(name = "StatusEnabled", columnDefinition = cDefStatusEnabled)
    @NotNull(message = "bankaccount.statusenabled.notnull")
    @Type(type = "org.hibernate.type.NumericBooleanType") private Boolean statusEnabled;
    
    private static final String cDefNoRec = VARCHAR + AWAL_KURUNG + 36 + AKHIR_KURUNG ;
    @Column(name = "NoRec", columnDefinition = cDefNoRec)
    @NotNull(message = "bankaccount.norec.notnull")
    private String noRec;
    
    private static final String cDefVersion =INTEGER;
    @Version
    @Column(name = "version", nullable = false,  columnDefinition = cDefVersion)
    @NotNull(message = "bankaccount.version.notnull")
    private Integer version;
    

    
    @ManyToOne(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdProfile", referencedColumnName="KdProfile",insertable=false, updatable=false),
    })
    //@ForeignKey(name="none")
     private Profile profile;
    
    @ManyToOne(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdProfile", referencedColumnName="KdProfile",insertable=false, updatable=false),
        @JoinColumn(name="KdRekanan", referencedColumnName="KdRekanan",insertable=false, updatable=false),
    })
    //@ForeignKey(name="none")
     private Rekanan rekanan;
    
    @ManyToOne(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdProfile", referencedColumnName="KdProfile",insertable=false, updatable=false),
        @JoinColumn(name="KdPegawai", referencedColumnName="KdPegawai",insertable=false, updatable=false),
    })
    //@ForeignKey(name="none")
     private Pegawai pegawai;
    
    @ManyToOne(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdProfile", referencedColumnName="KdProfile",insertable=false, updatable=false),
        @JoinColumn(name="KdCaraBayar", referencedColumnName="KdCaraBayar",insertable=false, updatable=false),
    })
    //@ForeignKey(name="none")
     private CaraBayar caraBayar;
    
    @ManyToOne(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdProfile", referencedColumnName="KdProfile",insertable=false, updatable=false),
        @JoinColumn(name="KdDepartemen", referencedColumnName="KdDepartemen",insertable=false, updatable=false),
    })
    //@ForeignKey(name="none")
     private Departemen departemen;
}
